unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, db, sqldb, sqlite3conn, FileUtil, Forms, Controls,
  Graphics, Dialogs, Buttons, DBGrids, DbCtrls, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    CheckBox1: TCheckBox;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    SQLite3Connection1: TSQLite3Connection;
    SQLQuery1: TSQLQuery;
    SQLTransaction1: TSQLTransaction;
    procedure Button1Click(Sender: TObject);
    procedure CheckBox1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    FColWidths: array of Integer;

  public
    procedure AddData;

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

const
  QUERY_SQL = 'SELECT ID, Firstname as "First Name", LastName as "Last Name", Mail, Phone FROM Clients';


type
  TMyDBGrid = class(TDBGrid)
  public
    property ColWidths;
  end;

{ TForm1 }

procedure TForm1.AddData;
const
  FIRST_NAMES: array[0..7] of String = ('Tom', 'Mary', 'Bill', 'Susan', 'John', 'Jane', 'Robert', 'Eddie');
  LAST_NAMES: array[0..7] of String = ('Miller', 'Jones', 'Dylan', 'Johnson', 'Fonda', 'McGraw', 'Walker', 'Murray');
  MAIL: array[0..3] of String = ('test.com', 'mail.com', 'fast.com', 'slow.com');
begin
  SQLQuery1.Close;
  SQLQuery1.SQL.Clear;
  SQLQuery1.SQL.Add('INSERT INTO Clients (FirstName, LastName, Mail, Phone)');
  SQLQuery1.SQL.Add('  VALUES(:FirstName, :LastName, :Mail, :Phone)');
  SQLQuery1.ParamByName('FirstName').AsString := FIRST_NAMES[Random(Length(FIRST_NAMES))];
  SQLQuery1.ParamByName('LastName').AsString := LAST_NAMES[Random(Length(LAST_NAMES))];
  SQLQuery1.ParamByName('Mail').AsString := MAIL[Random(Length(Mail))];
  SQLQuery1.ParamByName('Phone').AsString := FormatFloat('000', Random(1000)) + '-' + FormatFloat('000', Random(1000)) + '-' + FormatFloat('0000', Random(10000));
  SQLQuery1.ExecSQL;
  SQLTransAction1.Commit;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  i: Integer;
begin
  AddData;
  SQLQuery1.SQL.Text := QUERY_SQL;
  SQLQuery1.Open;
  for i := 0 to DBGrid1.Columns.Count-1 do
    if DBGrid1.Columns[i].Width > 300 then
      DBGrid1.Columns[i].Width := 300;
end;

procedure TForm1.CheckBox1Change(Sender: TObject);
begin
  DBGrid1.Options := DBGrid1.Options + [dgAutoSizeColumns];
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  newDB: Boolean;
  fn: String;
  i: Integer;
begin
  fn := Application.Location + 'data.db';
  newDB := not FileExists(fn);

  SQLite3Connection1.DatabaseName := fn;
  SQLite3Connection1.Connected := True;
  SQLTransaction1.DataBase := SQLite3Connection1;
  SQLQuery1.DataBase := SQLite3Connection1;
  SQLTransaction1.Active := True;

  if newDB then
  begin
    SQLite3Connection1.ExecuteDirect('CREATE TABLE Clients( ' +
      'ID INTEGER PRIMARY KEY, ' +
      'FirstName STRING, ' +
      'LastName STRING, ' +
      'Mail VARCHAR, ' +
      'Phone VARCHAR[20] )'
    );
    SQLTransaction1.Commit;

    Randomize;
    AddData;
    AddData;
    AddData;
  end;

  SQLQuery1.SQL.Text := 'SELECT * FROM Clients';
  SQLQuery1.Open;
  DataSource1.DataSet := SQLQuery1;
  DBGrid1.DataSource := DataSource1;

  for i := 0 to DBGrid1.Columns.Count-1 do
    if DBGrid1.Columns[i].Width > 300 then
      DBGrid1.Columns[i].Width := 300;
end;

end.

